Index: /branches/HeuristicLab.DiversityAnalysis/HeuristicLab.Problems.TravelingSalesman.Views/3.3/HeatmapView.Designer.cs
===================================================================
--- /branches/HeuristicLab.DiversityAnalysis/HeuristicLab.Problems.TravelingSalesman.Views/3.3/HeatmapView.Designer.cs	(revision 4699)
+++ /branches/HeuristicLab.DiversityAnalysis/HeuristicLab.Problems.TravelingSalesman.Views/3.3/HeatmapView.Designer.cs	(revision 4700)
@@ -24,10 +24,8 @@
     /// </summary>
     private void InitializeComponent() {
-      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(HeatmapView));
-
       System.Windows.Forms.DataVisualization.Charting.ChartArea chartArea1 = new System.Windows.Forms.DataVisualization.Charting.ChartArea();
       System.Windows.Forms.DataVisualization.Charting.Legend legend1 = new System.Windows.Forms.DataVisualization.Charting.Legend();
       System.Windows.Forms.DataVisualization.Charting.Title title1 = new System.Windows.Forms.DataVisualization.Charting.Title();
-
+      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(HeatmapView));
       this.chart = new HeuristicLab.Visualization.ChartControlsExtensions.EnhancedChart();
       this.ColorsPictureBox = new System.Windows.Forms.PictureBox();
@@ -43,9 +41,34 @@
                   | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.chart.Location = new System.Drawing.Point(3, 3);
+      this.chart.BorderlineColor = System.Drawing.Color.Black;
+      this.chart.BorderlineDashStyle = System.Windows.Forms.DataVisualization.Charting.ChartDashStyle.Solid;
+      chartArea1.AxisX.IntervalAutoMode = System.Windows.Forms.DataVisualization.Charting.IntervalAutoMode.VariableCount;
+      chartArea1.AxisX.LabelAutoFitStyle = ((System.Windows.Forms.DataVisualization.Charting.LabelAutoFitStyles)((System.Windows.Forms.DataVisualization.Charting.LabelAutoFitStyles.IncreaseFont | System.Windows.Forms.DataVisualization.Charting.LabelAutoFitStyles.DecreaseFont)));
+      chartArea1.AxisX.Title = "Solution Index";
+      chartArea1.AxisY.Maximum = 1D;
+      chartArea1.AxisY.Minimum = 0D;
+      chartArea1.AxisY.Title = "Solution Index";
+      chartArea1.CursorX.IsUserEnabled = true;
+      chartArea1.CursorX.IsUserSelectionEnabled = true;
+      chartArea1.CursorY.IsUserEnabled = true;
+      chartArea1.CursorY.IsUserSelectionEnabled = true;
+      chartArea1.Name = "Default";
+      this.chart.ChartAreas.Add(chartArea1);
+      legend1.Alignment = System.Drawing.StringAlignment.Center;
+      legend1.Docking = System.Windows.Forms.DataVisualization.Charting.Docking.Top;
+      legend1.Name = "Default";
+      this.chart.Legends.Add(legend1);
+      this.chart.Location = new System.Drawing.Point(0, 0);
       this.chart.Name = "chart";
-      this.chart.Size = new System.Drawing.Size(400, 352);
+      this.chart.Size = new System.Drawing.Size(403, 358);
       this.chart.TabIndex = 0;
       this.chart.Text = "chart";
+      title1.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
+      title1.Name = "Default";
+      title1.Text = "Solution Similarities";
+      this.chart.Titles.Add(title1);
+      this.chart.CustomizeLegend += new System.EventHandler<System.Windows.Forms.DataVisualization.Charting.CustomizeLegendEventArgs>(this.chart_CustomizeLegend);
+      this.chart.MouseDown += new System.Windows.Forms.MouseEventHandler(this.chart_MouseDown);
+      this.chart.MouseMove += new System.Windows.Forms.MouseEventHandler(this.chart_MouseMove);
       // 
       // ColorsPictureBox
Index: /branches/HeuristicLab.DiversityAnalysis/HeuristicLab.Problems.TravelingSalesman.Views/3.3/HeatmapView.cs
===================================================================
--- /branches/HeuristicLab.DiversityAnalysis/HeuristicLab.Problems.TravelingSalesman.Views/3.3/HeatmapView.cs	(revision 4699)
+++ /branches/HeuristicLab.DiversityAnalysis/HeuristicLab.Problems.TravelingSalesman.Views/3.3/HeatmapView.cs	(revision 4700)
@@ -47,5 +47,56 @@
       InitializeComponent();
       chart.CustomizeAllChartAreas();
+      /*
+      Series s = new Series();
+      DataPoint p = new DataPoint(0.4, 0.2);
+      p.Color = Color.Red;
+      p.MarkerStyle = MarkerStyle.None;
+      p.MarkerSize = 10;
+      s.Points.Add(p);
+      DataPoint p2 = new DataPoint(0.6, 0.5);
+      p2.Color = Color.Red;
+      p2.MarkerStyle = MarkerStyle.None;
+      p2.MarkerSize = 40;
+      s.Points.Add(p2);
+      DataPoint p3 = new DataPoint(0.8, 0.2);
+      p3.Color = Color.Red;
+      p3.MarkerStyle = MarkerStyle.None;
+      p3.MarkerSize = 40;
+      s.Points.Add(p3);
+      DataPoint p4 = new DataPoint(0.7, 0.3);
+      p4.Color = Color.Red;
+      p4.MarkerStyle = MarkerStyle.None;
+      p4.MarkerSize = 40;
+      s.Points.Add(p4);
+      s.ChartType = SeriesChartType.Area;
+      s.XValueType = ChartValueType.String;
+      s.YValueType = ChartValueType.Double;
+      s.YAxisType = AxisType.Primary;
+      chart.Series.Add(s);
+      chart.Update();*/
     }
+
+    #region Chart Events
+    protected virtual void chart_MouseDown(object sender, MouseEventArgs e) {
+      HitTestResult result = chart.HitTest(e.X, e.Y);
+      //
+    }
+
+    protected virtual void chart_MouseMove(object sender, MouseEventArgs e) {
+      HitTestResult result = chart.HitTest(e.X, e.Y);
+      if (result.ChartElementType == ChartElementType.LegendItem)
+        this.Cursor = Cursors.Hand;
+      else
+        this.Cursor = Cursors.Default;
+    }
+
+    protected virtual void chart_CustomizeLegend(object sender, CustomizeLegendEventArgs e) {
+      foreach (LegendItem legendItem in e.LegendItems) {
+        var series = chart.Series[legendItem.SeriesName];
+        //
+      }
+    }
+
+    #endregion
 
   }
Index: /branches/HeuristicLab.DiversityAnalysis/HeuristicLab.Problems.TravelingSalesman/3.3/Analyzers/TSPPopulationDiversityAnalyzer.cs
===================================================================
--- /branches/HeuristicLab.DiversityAnalysis/HeuristicLab.Problems.TravelingSalesman/3.3/Analyzers/TSPPopulationDiversityAnalyzer.cs	(revision 4699)
+++ /branches/HeuristicLab.DiversityAnalysis/HeuristicLab.Problems.TravelingSalesman/3.3/Analyzers/TSPPopulationDiversityAnalyzer.cs	(revision 4700)
@@ -61,4 +61,5 @@
     }
 
+    public const string CurrentSimilaritiesKey = "Current Solution Similarities";
     public const string CurrentAverageSimilarityKey = "Current Average Population Similarity";
     public const string AverageSimilarityProgressKey = "Average Population Similarity Progress";
@@ -132,4 +133,10 @@
       DoubleValue averageSimilarity = new DoubleValue(avgSimilarity / n);
 
+      #region Store current solution similarities
+      if (results.ContainsKey(CurrentAverageSimilarityKey))
+        results[CurrentSimilaritiesKey].Value = similarities;
+      else
+        results.Add(new Result(CurrentSimilaritiesKey, similarities));
+      #endregion
       #region Store average similarity values
       if (results.ContainsKey(CurrentAverageSimilarityKey))
